#include<fstream>
#include<sstream>
#include<cstring>
using namespace std;
int main()
{
	ifstream f1("STRD4.INP");
	ofstream f2("STRD4.OUT");
	string s;
	f1>>s;
	f1.close();
	int n=s.length();
	int i;
	int u=0;
	for(i=0;i<n;i++)
	{
		if((int(s[i])-48)%4==0) u++;
		//f2<<s[i]<<endl;
	}
	for(i=0;i<n-1;i++)
	{
		int v=int(s[i])-48;
		int p=int(s[i+1])-48;
		if((v*10+p)%4==0) 
		{
			u+=i+1;
		}
	}
	f2<<u;
	return 0;
}

